/************/
/* bitmap.h */
/************/

#ifndef BITMAP_H
#define BITMAP_H

#include "incwin.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef BYTE huge *bmHDIB;

WORD bmGetDibWidth(bmHDIB lpDib);
WORD bmGetDibHeight(bmHDIB lpDib);
HBITMAP bmFileLoadBitmap(LPCSTR name);
HBITMAP bmFileOrResLoadBitmap(HINSTANCE hInst,LPCSTR name);
int bmDrawDib(HDC hDC,bmHDIB lpDib,int x,int y);
bmHDIB bmReadDib(LPCSTR szFileName);
int bmDeleteDib(bmHDIB lpDib);

typedef struct tagtOneBitmap {
  HBITMAP hBitmap;
  char    name[100];
  struct tagtOneBitmap *next;
} tOneBitmap;

typedef struct {
  tOneBitmap *first;
  tOneBitmap *last;
} tbmBitmapCache;

HBITMAP bmFindBitmap(HINSTANCE hInst,const char *name, tbmBitmapCache *bc);
int bmDeleteBitmapCache(tbmBitmapCache *bc);
int bmDrawBitmap(HDC hDC,HBITMAP hBitmap,int x,int y);
int bmDrawBitmapName(HINSTANCE hInstance, HDC hDC,const char *name,
                     int x,int y, tbmBitmapCache *bc);

#ifdef __cplusplus
}
#endif

#endif /* BITMAP_H */
