/**************/
/* ddeser.c   */
/****************************************************************************
  PROGRAM: ddeser
  PURPOSE: dde-palvelimen yksinkertainen kytt
  AUTHOR:  Vesa Lappalainen 13.8.1993
           Kari Heikkil -92 ( alkuperinen ei-aliohjelmaversio )
  USAGE:   ( toistaiseksi tuetaan vain CF_TEXT -muotoa)
    Projektiin laitettava ddeser.c ja clipboard.c.

    Esimerkiksi EXCELIN kaavassa:
           =AUTOLDDE|LKM!HA
               ^       ^  ^
               |       |  | item
               |       | topic
               | service

    Jotta oma ohjelma osaisi vastata Excelin DDE-kyselyyn
    (Excel on tllin asiakas, client), pit omaan ohjelmaan
    tehd muutamia lisyksi.

    Pasiallisesti on kaksi vaihtoehtoa.
    A) Annetaan ddeser-kirjaston pit huolta yhdistelmist.
    B) Pidetn itse kirjaa topic/item yhdistelmist, joihin ostataan
       vastata.
    C) Edellisten sekoitus.

    A-kohta voidaan jakaa viel kahteen alakohtaan:
    a) Palvelun tuloksena halutaan antaa jonkin dialogi-ikkunan
       sislt, joka voidaan selvitt kutsulla GetWindowText.
       Tllin voidaan ddeser-kirjaston antaa huolehtia kaikesta
       automaattisesti.
    b) Huolehditaan itse palveluista

    Kaikkein helpointa kytt on kohdan Aa-mukaisesti.  Seuraavassa
    ksitelln kutakin tapaa erikseen:

  Aa) DDESER-kirjasto huolehtii palveluista:
  ------------------------------------------
    1) (p)ohjelmaan listtv alustus ja lopetus:
          InitDDEServer(hInstance,SERVICE,NULL);
           ...
          CloseDDEServer();

       SERVICE on palvelun nimi (yleens sama kuin ohjelman nimi)

    2) Kun palvelut halutaan aktiiviseksi, listn (vaikka
       heti InitDDEServer-rivin jlkeen:
          AddAutoTextService(topic1,item1,ID1,hWnd);
          AddAutoTextService(topic2,item2,ID2,hWnd);
          ...

       Nyt luetaan automaattisesti dialogin hWnd kentti
       ID1,...  hWnd voi tietysti olla erikin kullekin alustukselle.

    3) Jos halutaan automaattinen pivitys, niin tytyy kutsua
          InformDDEChangeSN(ID1);

       aina kun kentn ID1 sislt on muuttunut.

    4) Jos halutaan leikekirjaan tieto miten tehdn linkki
       esimerkiksi kenttn ID1, kutsutaan
          LinkToClipboardSN(hWnd,ID1)

       Nyt esim. Exceliss linkki voidaan muodostaa valitsemalla
       Edit/Paste Link.

    Siis minimissn 2-3 lisyst ohjelmaan riitt!

  Ab) DDESER-kirjasto huolehtii palveluista, itse palvellaan
  -----------------------------------------------------------
    1) Kuten edell
    2) Kun palvelut halutaan aktiiviseksi, listn (vaikka
       heti InitDDEServer-rivin jlkeen:
          AddDDEService(topic1,item1,fmt1,ID1,MyFunc1,NULL);
          AddDDEService(topic2,item2,fmt2,ID2,MyFunc2,NULL);
          ...
    3) & 4) kuten edell

    5) Kirjoitetaan funktiot MyFunc1 ja MyFunc2
         char *MyFunc1(int n)

       jotka palauttavat palvelua n vastaavan osoittimen haluttuun
       dataan.


  B) Huolehditaan itse topic/item yhdistelmist:
  ----------------------------------------------

    1) (p)ohjelmaan listtv alustus ja lopetus:
          InitDDEServer(hInstance,SERVICE,MyGetData);
           ...
          CloseDDEServer();

       SERVICE on palvelun nimi (yleens sama kuin ohjelman nimi)

    2) Kirjoitettava funktiot:
          char *MyGetData(char *topic, char *item, UINT wFmt,int query);

       Jos query!=0 on tehtvn on vastata kysymykseen, lytyyk
       aihetta topic ja asiaa item ja formaattia wFmt. Jos lytyy
       palautetaan osoitin joka on !=NULL, Jollei lydy, niin osoitin NULL.

       Jos query==0, palautetaan topic/item/wFmt:t vastaava merkkijono,
       jos sellainen on olemassa TAI NULL jollei ole.
       Merkkijono palautetaan osoitteena staattiseen
       tai globaaliin muuttujaan, jonka DDESER kopioi heti itselleen
       eik muuta osoitteen sislt.

    3) Jos DDE-yhteydess halutaan ilmoittaa asiakkaalle kaikki
       muutokset, pit viel kirjoittaa muutoksen tapahtuttua kutsu:
          InformDDEChange(topic,item);

    4) Jos halutaan kopioida DDE-linkin vaatima tieto leikekirjaan,
       listn sopivaan kohtaan (esim kommennon Edit/Copy alle)
       kutsu:
          LinkToClipboard(hWnd,topic,item);

Kyttehdotuksia:
-----------------
  Tapa Aa on helpoin jos on vhn ikkunoita, joista palvelua halutaan
  antaa.

  Tapa Ab sopii jos on vhn palveluita, mutta ne ovat jotakin, joka
  ei ole valmiina jossakin dialogin ikkunassa.  Esimerkiksi kahden
  ikkunan summa.

  Tapa B sopii, jos palveluita on suuri mr, esimerksiksi taulukkolaskimessa
  on palveluina kaikki solut ja tllin item-nimet ovat muotoa R1C1,R1C2 jne.
  Tllin omaan palvelufunktioon on helpointa tehd tulkki, joka
  osaa palauttaa oikean asian.

  Kaikki tavat Aa, Ab ja B ovat mahdollisia sotkea samassa ohjelmassa.
  Esimerkiksi:
    dialogin kaksi kent HA ja KA tavalla Aa
    kenttien summa  HA+KA          tavalla Ab
    monimutkaiset tiedot (???)     tavalla B

   1) Alustus:
          InitDDEServer(hInstance,SERVICE,MyGetData);
          AddDDEService("Lkm","ha",0,HA,NULL,hWnd);
          AddDDEService("Lkm","ka",0,KA,NULL,hWnd);
          AddDDEService("Lkm","sum",0,SUM,MySum,NULL);

   2) Kirjoitetaan monimutkaiset tiedot ksittelev funktio:
          char *MyGetData(char *topic, char *item, UINT wFmt,int query)
          {
             static char result[100];
             if ( !IsLeagal(topic,item,wFmt) ) return NULL;
             if ( query ) return result;
             FillResult(topic,item,wFmt,result,sizeof(result));
             return result;
          }

   3) Kirjoitetaan summan ksittelev funktio ( WindInt(int n) oletetaan
      palauttavan tavalla tai toisella n:en ikkunan sislln kokonaislukuna):
          char *MySum(int n)
          {
             static char csum[20];
             int sum = WindInt(HA) + WindInt(KA) ;
             sprintf(csum,"%d\r\n",sum);
             return csum;
          }

   4) Kun HA tai KA ikkunan sislt muuttuu, niin:
          InformDDEChangeSN(HA);
          InformDDEChangeSN(SUM);
          InformDDEChange(DIFFICULT_TOPIC,DIFFICULT_ITEM);

============
Aliohjelmat: (ddeser.c, ddeser.h)
============
  BOOL InitDDEServer(HINSTANCE hInst,char *service,tServerFunc func) - alustus
  BOOL CloseDDEServer( void )                                     - lopetus
  void InformDDEChange(char *topic, char *item) - muutoksen ilmoittaminen
  void InformDDEChangeSN(int sn)                - muutoksen ilmoittaminen
  DWORD LinkToClipboardSN(HWND hWnd,int sn)
  DWORD LinkToClipboard(HWND hWnd,char *topic,char *item)
    - leikekirjaan itse staattinen tieto, DDE-linkin vaatima tieto
      (jotta saadaan kaava esim. taulukkolaskennassa Edit/Paste Link)
      sek Clipboard vieweria varten viel nyttn tuleva teksti.

  tService *FindService(char *topic, char *item, UINT wFmt);
    - palautetaan topic/item/wFmt -palvelua vastaavan tietueen osoitin
  tService *FindServiceSN(int sn);
    - palautetaan palvelunumeroa sn vastaavan tietueen osoitin

    Tietueen sislt ks. ddeser.h.  Nut kytetn mm.
    jos tarvitsee saada ikkunan kahva tai topic/item selville
    kesken palvelun.

  int DeleteDDEService(char *topic,char *item, int sn);
    - poistaa kaikki palevelut topic/item ja/tai ne joilla
      on palvelunumero sn.  Jos topic==NULL, niin vain sn
      tutkitaan, jos sn == 0, niin vain topic/item tutkitaan.

  int AddAutoTextService(topic,item,sn,hWnd)
    - makro joka kutsuu seuraavaa funktiota wFmt = CF_TEXT
      ja ServerFuncN = NULL
      
  int AddDDEService(char *topic,char *item, UINT wFmt, int sn,
                 tServerFuncN ServerFuncN, HWND hWnd);
    - listn palvelujen listaan palvelu jolla on annettu
        topic/item/wFmt
      jos yhdistelm lytyy jo ennestn, korvataan sen tiedot.
      Palvelusta kytetn jatkossa numeroa sn.
      Kun palvelua pyydetn, niin toimitaan seuraavan
      algortimin mukaan:
        A) Jos palvelu lytyy listasta
          b) jos ServerFuncN annettu, kutsutaan sit
          a) jos hWnd annettu ja CF_TEXT-pyynt, niin
             otetaan ikkunan hWnd kentn sn sislt
          c) palautetaan virheteksti
        B) Jos funktio annettu InitDDEServer-kutsussa, kutsutaan
           sit.

      Huomattakoon, ett samaa topic/item-yhdistelm voi
      vastata useita eri wFmt-muotoja.


====================
Itsekirjoitettavat:  (oma.c)
====================
  const char *MyGetData(const char *topic, const char *item, UINT wFmt, int query)
    - palauttaa NULL jos topic & item & wFmt ei lydy, muuten palauttaa
      topic & itemia vastaavan merkkijonon jos query==0 tai
      mink tahansa != NULL osoittimen jos query != 0


****************************************************************************/
#include <windows.h>
#include <ddeml.h>              /* DDE Management Library */          /* d */
#include <string.h>
#include "ddeser.h"
#include "clipboar.h"

/***************************************************************************/
/* DDE:                                                                    */
/***************************************************************************/

typedef struct {
  DWORD        idInst;           /* Ohjelman DDECallback funktion esiintym*/
  HCONV        hConvApp;         /* Keskustelukahva                        */
  FARPROC      lpDdeProc;        /* DDECallback funktion osoitin           */
  HSZ          hszService;       /* Merkkijonokahva palvelun nimeen        */
  HDDEDATA     reg;              /* Onko palvelu kirjattu                  */
  tServerFunc  ServerFunc;       /* Topic, Item, format -> vast.merk.jono  */
  tService     Services[MAX_SERVICE];  /* Taulukko palveluista             */
} tDDEServer;

static tDDEServer DDE = {0,0,0,0,0,0};


/***************************************************************************/
/* Service taulukon ksittely alkaa                                        */
/***************************************************************************/

/*-------------------------------------------------------------------------*/
/* Taulukon muodon (miten indeksoitu) tietvt funktiot:                   */
#define ST DDE.Services

/***************************************************************************/
static tService *GetDDEService(int n)
/* Indeksia n vastaava palvelu                                             */
{
  if ( n < 0 || MAX_SERVICE <= n ) return NULL;
  return ST+n;
}


/***************************************************************************/
static int TableIndexSN(int sn)
/* Etsitn palvelunumeroa sn vastaavan palvelun indeksi                   */
/* -1 = ei lydy                                                           */
{
  int i;
  for (i=0; i<MAX_SERVICE; i++)
    if ( sn == ST[i].sn ) return i;
  return -1;
}


/***************************************************************************/
static int TableIndex(const char *topic, const char *item, UINT wFmt)
/* Etsitn palvelua topic/item/wFmt vastaavan palvelun indeksi            */
/* -1 = ei lydy                                                           */
{
  int i;
  for (i=0; i<MAX_SERVICE; i++)
    if ( ( ST[i].wFmt == wFmt || wFmt == 0xffff ) && ST[i].topic &&
         strcmpi(ST[i].topic,topic) == 0 && strcmpi(ST[i].item,item) == 0 )
      return i;
  return -1;
}
#undef ST
/* Paikan tietvt funktiot loppuivat                                      */
/*-------------------------------------------------------------------------*/


/***************************************************************************/
tService *FindServiceSN(int sn)
/* Palautetaan palvelunumeroa sn vastaavan palvelun osoite tai NULL        */
{
  return GetDDEService(TableIndexSN(sn));
}

/***************************************************************************/
tService *FindService(const char *topic, const char *item, UINT wFmt)
/* Palautetaan palvea topic/item/wFmt vastaavan palvelun osoite tai NULL   */
{
  return GetDDEService(TableIndex(topic,item,wFmt));
}


/***************************************************************************/
static int DeleteDDEServiceS(tService *Ser)
/* Poistetaan palvelu, jonka osoite on Ser                                 */
{
  if ( !Ser ) return 1;
  Ser->topic[0] = 0;
  Ser->sn    = 0;
  return 0;
}


/***************************************************************************/
static int PutService(tService *Ser,tService *NewSer)
/* Laitetaan palveluksi Ser palvelu joka on osoitteessa NewSer             */
{
  if ( !Ser ) return 1;
  if ( NewSer->topic[0] == 0 ) return 2;
  *Ser = *NewSer;
  return 0;
}


/***************************************************************************/
static int AddNewService(tService *NewSer)
/* Listn palvelu NewSer (tehdn kopio)                                 */
{
  tService *Ser=FindServiceSN(0);
  if ( !Ser ) return 1;
  return PutService(Ser,NewSer);
}


/***************************************************************************/
/* Service taulukon ksittely loppuu                                       */
/***************************************************************************/


/***************************************************************************/
static BOOL IsItem(HSZ hszTopic, HSZ hszItem,UINT wFmt)
/* Lytyyk palvelua                                                       */
{
  char szItem[20],szTopic[20];

  DdeQueryString(DDE.idInst, hszTopic, szTopic, sizeof(szTopic), 0);
  DdeQueryString(DDE.idInst, hszItem, szItem, sizeof(szItem), 0);

  /* Tarkistetaan, lytyyk palvelu taulukoiduista                         */
  if ( FindService(szTopic,szItem,wFmt) ) return TRUE;

  /* Onko palvelufunktiota ja jos on, niin mit se palauttaa.              */
  if ( DDE.ServerFunc ) return DDE.ServerFunc(szTopic,szItem,wFmt,1) != NULL;

  return FALSE;
}


/***************************************************************************/
static const char *GetDDEDataC(const char *szTopic, const char *szItem,UINT wFmt)
/* Palautetaan palvelua vastaava merkkijono.
** Jollei pystyt palvelemaan, palautetaan NULL
** A) Ensin etsitn voidaanko palvelu lyt palvelutaulukosta
**    b) Jos palvelulle funktio, kutsutaan sit
**    a) Jos ikkunasta tiedot, niin otetaan ne
** B) Kutsutaan yleist palvelufunktiota
*/
{
  tService *Ser;

  /* Tarkistetaan, lytyyk palvelu taulukoiduista                         */
  if ( ( Ser = FindService(szTopic,szItem,wFmt) ) != NULL ) {
    if ( Ser->ServerFuncN ) /* Jos palvelulle oma funktio, niin kuts. sit */
      return Ser->ServerFuncN(Ser->sn);

    if ( Ser->hWnd && wFmt == CF_TEXT ) { /* Jos dialogin kentt, luet. se */
      static char buf[200];
      HWND hsWnd = GetDlgItem(Ser->hWnd,Ser->sn);
      if ( !hsWnd ) return "No dialog item";
      GetWindowText(hsWnd,buf,sizeof(buf));
      return buf;
    }
  }

  /* Onko palvelufunktiota ja jos on, niin mit se palauttaa.              */
  if ( DDE.ServerFunc ) return DDE.ServerFunc(szTopic,szItem,wFmt,0);

  return NULL;
}


/***************************************************************************/
static const char *GetDDEData(HSZ hszTopic, HSZ hszItem,WORD wFmt)
/* Kuten edell, mutta merkkijonot kahvojen perusteella                    */
{
  char szItem[20],szTopic[20];

  DdeQueryString(DDE.idInst, hszTopic, szTopic, sizeof(szTopic), 0);
  DdeQueryString(DDE.idInst, hszItem, szItem, sizeof(szItem), 0);
  return GetDDEDataC(szTopic,szItem,wFmt);
}


/***************************************************************************/
static DWORD MyError(char *szVirheMessu)
{
  MessageBox(NULL,szVirheMessu,NULL,
              MB_APPLMODAL |  MB_OK | MB_ICONEXCLAMATION);
  return 0;
}


/***************************************************************************/
static DWORD MyInfo(const char *szInfoMessu)
{
  MessageBox(NULL, szInfoMessu, "DDE", MB_APPLMODAL |  MB_OK);
  return 0;
}


/***************************************************************************/
void InformDDEChange(const char *topic, const char *item)
/* Vlitetn DDE-palvelimelle tieto, ett tieto on muuttunut              */
{
  HSZ hszItem,hszTopic;

  hszItem = DdeCreateStringHandle(DDE.idInst, item, 0);
  hszTopic = DdeCreateStringHandle(DDE.idInst, topic, 0);
  DdePostAdvise(DDE.idInst, hszTopic, hszItem );
  DdeFreeStringHandle(DDE.idInst, hszTopic );
  DdeFreeStringHandle(DDE.idInst, hszItem );
}


/***************************************************************************/
void InformDDEChangeSN(int sn)
{
  tService *Ser = FindServiceSN(sn);
  if ( Ser ) InformDDEChange(Ser->topic,Ser->item);
}


/***************************************************************************/
HDDEDATA EXPENTRY _export DDECallbackServer (
   WORD wType,     /* transaktion tyyppi                                   */
   WORD wFmt,      /* datan tyyppi (clipboard type)                        */
   HCONV hConv,    /* keskustelukahva                                      */
   HSZ hsz1,       /* merkkijonokahva, kts. ko. transaktiosta              */
   HSZ hsz2,       /* "                                                    */
   HDDEDATA hData, /* kahva globaaliin muistilohkoon                       */
   DWORD dwData1,  /* transaktiokohtaista dataa                            */
   DWORD dwData2 ) /* "                                                    */
{
#pragma argsused
  char szBuffer[100];
  const char *p;

  switch ( wType )   {

    case XTYP_CONNECT:    /* Asiakas haluaa avata keskustella              */
                                        /* hsz1 = topic                    */
                                        /* hsz2 = service                  */
      if ( hsz2 == DDE.hszService )
        return (HDDEDATA)TRUE;  /* Meill on sopiva keskusteluaihe, ok     */
      else
        return (HDDEDATA)FALSE; /* Ei sopivaa aihetta                      */

    case XTYP_ADVSTART:   /* Asiakas haluaa tiet jokaisesta muutoksesta  */
    case XTYP_ADVSTOP:    /* Asiakas ei en halua tiet ...              */
                                        /* hsz1 = topic                    */
                                        /* hsz2 = item                     */
      /* Tarkistetaan, ett pyydetty toiminto lytyy                       */
      if ( IsItem(hsz1,hsz2,wFmt) )
        /* Jos toiminto lytyi, palautetaan asiakkaalle mynteinen vastaus */
        return (HDDEDATA)TRUE;

      return (HDDEDATA)FALSE; /* Ei lydy                                  */

    case XTYP_REQUEST:    /* Asiakas pyytnyt dataa                        */
    case XTYP_ADVREQ:     /* Data muuttunut palvelimella                   */
                                        /* hsz1 = topic                    */
                                        /* hsz2 = item                     */
      if ( ( p = GetDDEData(hsz1,hsz2,wFmt) ) == NULL )
        return NULL;                 /* Ei lydy toimintoa                 */

      strcpy(szBuffer,p);

      return DdeCreateDataHandle(DDE.idInst,(void *)p,strlen(p)+1,0L,hsz2,CF_TEXT,0);

    case XTYP_CONNECT_CONFIRM:  /* Asiakas hyvksynyt keskusteluyhteyden   */
                                        /* hsz1 = topic                    */
                                        /* hsz2 = service                  */
      DDE.hConvApp = hConv;
      break;

    case XTYP_DISCONNECT:  /* Asiakas halusi lopettaa keskustelun          */
                                        /* hsz1 = topic                    */
                                        /* hsz2 = service                  */
//      MyInfo( "DDE asiakas sulki yhteyden." );
      DDE.hConvApp = NULL;
      break;

    case XTYP_ERROR: /* Jokin virhe                                        */
      MyInfo( "DDE virhe." );
      break;
  }

  return NULL;
}


/***************************************************************************/
static int CloseDDEServerError(int ret)
{
  CloseDDEServer();
  return ret;
}


/***************************************************************************/
int InitDDEServer(HINSTANCE hInst,const char *service,tServerFunc ServerFunc)
{
  (void)hInst;
  DDE.lpDdeProc = MakeProcInstance( (FARPROC) DDECallbackServer, hInst );
  if ( !DDE.lpDdeProc ) return 1;

  if ( DdeInitialize(&DDE.idInst,(PFNCALLBACK)DDE.lpDdeProc,
           APPCLASS_STANDARD | CBF_FAIL_EXECUTES | CBF_FAIL_POKES,0L ) ) {
    MyError( "DDE:n alustus ei onnistu!" );
    return CloseDDEServerError(2);
  }

  DDE.hszService = DdeCreateStringHandle(DDE.idInst, service, 0);
  if ( !DDE.hszService ) return CloseDDEServerError(3);

  /* Rekisteridn palvelu                                              */
  DDE.reg = DdeNameService(DDE.idInst, DDE.hszService, NULL, DNS_REGISTER);
  if ( !DDE.reg ) return CloseDDEServerError(4);

  DDE.ServerFunc = ServerFunc;

#ifdef MYINFO
  MyInfo( "DDE alustettu." );
#endif

  return 0;
}


/***************************************************************************/
int CloseDDEServer( void )
{
  if ( DDE.hConvApp )  { DdeDisconnect(DDE.hConvApp); DDE.hConvApp = NULL; }
  if ( DDE.reg ) { /* Poistetaan palvelu rekisterist                      */
    DdeNameService(DDE.idInst,DDE.hszService, NULL, DNS_UNREGISTER);
    DDE.reg = 0;
  }
  if ( DDE.hszService) { DdeFreeStringHandle(DDE.idInst, DDE.hszService); DDE.hszService = 0; }
  if ( DDE.idInst )    { DdeUninitialize(DDE.idInst); DDE.idInst = 0; }
  if ( DDE.lpDdeProc ) { (void)FreeProcInstance(DDE.lpDdeProc); DDE.lpDdeProc = NULL;}

 #ifdef MYINFO
  MyInfo ( "DDE suljettu." );
 #endif

  return 0;
}


/***************************************************************************/
DWORD LinkToClipboard(HWND hWnd,const char *topic,const char *item)
/* Leikekirjaan linkki, nyttteksti ja itse staattinen tieto.
*/
{
  DWORD ret;
  char pText[100];
  const char *p;
  int plen;

  if ( !DDE.idInst ) return -4;
  if ( !OpenClipboard(hWnd) ) return -1;

  DdeQueryString(DDE.idInst,DDE.hszService, pText, sizeof(pText)-1, 0);
  strcat(pText,"|"); plen=strlen(pText);
  strncat(pText,topic,sizeof(pText)-plen-1);
  strcat(pText,"!"); plen=strlen(pText);
  strncat(pText,item,sizeof(pText)-plen-1);

  ret = AddLinkToClipboard(NULL,pText,"Link",TRUE);
  p = GetDDEDataC(topic,item,CF_TEXT);
  if ( p && !ret ) ret = AddToClipboard(NULL,CF_TEXT,p,strlen(p)+1,FALSE);
  CloseClipboard();

  return ret;
}


/***************************************************************************/
DWORD LinkToClipboardSN(HWND hWnd,int sn)
/* Laitetaan leikekirjaan palvelua sn vastaavat tiedot linkkitietoineen
*/
{
  tService *Ser = FindServiceSN(sn);
  if ( !Ser ) return -5;
  return LinkToClipboard(hWnd,Ser->topic,Ser->item);
}

#define STRCPY(s,p) { strncpy(s,p,sizeof(s)); s[sizeof(s)-1] = 0; }
/***************************************************************************/
int AddDDEService(const char *topic,const char *item, UINT wFmt, int sn,
               tServerFuncN ServerFuncN, HWND hWnd)
/* Listn listaan uusi palvelu.  Jos palvelu on ennestn
** (sama topic,item,wFmt), niin muutetaan sen muut tiedot lismtt mitn.
** sn == 0 ei ole sallittu, vaan palauttaa virheen.
*/
{
  tService NewSer,*Ser=FindService(topic,item,wFmt);

  if ( !sn ) return -1;

  STRCPY(NewSer.topic,topic);
  STRCPY(NewSer.item,item);
  if ( wFmt == 0 ) wFmt = CF_TEXT; NewSer.wFmt = wFmt;
  NewSer.ServerFuncN = ServerFuncN; NewSer.hWnd = hWnd;
  NewSer.sn = sn;

  if ( Ser ) return PutService(Ser,&NewSer);
  return AddNewService(&NewSer);
}


/***************************************************************************/
int DeleteDDEService(const char *topic,const char *item, int sn)
/* Poistetaan kaikki palvelut joissa topic,item (jos ne != NULL)
** Poistetaan kaikki palvelut, joiden numero sn (>0).
** Jos topic == NULL, poistetaan vain sn:n perusteella.
** Jos sn == 0, poistetaan vain topic,item:in perusteella.
*/
{
  tService *Ser;
  int count = 0;
  if ( topic && item )
    while ( ( Ser = FindService(topic,item,0xffff) ) != NULL )
      if ( DeleteDDEServiceS(Ser) == 0 ) count++;

  if ( sn )
    while ( ( Ser = FindServiceSN(sn) ) != NULL )
      if ( DeleteDDEServiceS(Ser) == 0 ) count++;

  return count;
}