/**************/
/* ddeser.h   */
/**************/
#ifndef DDESER_H
#define DDESER_H

#include "incwin.h"

#define MAX_SERVICE 10
#define AddAutoTextService(topic,item,ID,hWnd) \
  AddDDEService(topic,item,CF_TEXT,ID,NULL,hWnd)

#ifdef __cplusplus
extern "C" {
#endif
typedef const char *(*tServerFunc)(const char *topic, const char *item, UINT wFmt, int query);
typedef const char *(*tServerFuncN)(int n);

typedef struct {
  char         topic[30];
  char         item[30];
  UINT         wFmt;
  int          sn;
  tServerFuncN ServerFuncN;
  HWND         hWnd;
} tService;

tService *FindServiceSN(int sn);
tService *FindService(const char *topic, const char *item, UINT wFmt);


void InformDDEChange(const char *topic, const char *item);
void InformDDEChangeSN(int sn);
BOOL CloseDDEServer( void );
BOOL InitDDEServer(HINSTANCE,const char *,tServerFunc);
DWORD LinkToClipboard(HWND hWnd,const char *topic,const char *item);
DWORD LinkToClipboardSN(HWND hWnd,int sn);
int AddDDEService(const char *topic,const char *item, UINT wFmt, int sn,
               tServerFuncN ServerFuncN, HWND hWnd);
int DeleteDDEService(const char *topic,const char *item, int sn);
#ifdef __cplusplus
}
#endif
#endif /* DDESER_H */