/**************/
/* dropfile.h */
/*****************************************************************
Module name: dropfile.h
Programmer : Vesa Lappalainen
Description: Drag and Drop functions, see dropfile.c
*****************************************************************/

#ifndef DROPFILE_H
#define DROPFILE_H

#include "incwin.h"
#include <shellapi.h>

#define UM_UPDATECAPTION   (WM_USER + 0)

#define WM_BEGINDRAG 0x022c  /* Undocumented Windows */
#define WES_NOTIFYDRAG 0x2L

#define SET_NOTIFYDRAG(hWnd) SetNotifyDrag(hWnd)

#define DAD_ONLYNAME 1
#define DAD_RESET    2
#define DAD_SMALL    4
#define DAD_DUB      8

#ifdef __cplusplus
extern "C" {
#endif
int SetNotifyDrag(HWND hWnd);

HDROP DragCreateFiles(LPPOINTS lpptMousePos,BOOL fInNonClientArea);
HDROP DragAppendFile(HGLOBAL hDrop, LPCSTR szPathname);

int GetSinglePathName (LPCSTR szFileOpenStr, int wIndex,
   LPSTR szPathName, int wMaxLen);

LPSTR MultiSelectFiles(HWND hWnd,LPSTR szAllFileNames,int mb);
int DropSelectFiles(HWND hWnd);

int DropFiles(HWND hWnd,LPSTR szAllFileNames,char sep);
int DropText(HWND hWnd,LPCSTR szAllFileNames);
int DropListBoxFiles(HWND hWnd,UINT id,LPCSTR path);
int DropListBoxText(HWND hWnd,UINT id);
LPSTR DropFilesToString(HDROP hDrop,LPSTR s,int mb);
int DropFilesToListBox(HDROP hDrop,HWND hWnd,int id,int opt);
LPCSTR RemovePath(LPCSTR s);
int InitDragAndDrop(const char *inifilename, int write);

int DaDOptionDialog(HWND hWnd);
int InitDaDOptions(const char *inifile);
int SaveDaDOptions(const char *inifile);

int CollectListBoxItems(HWND hWnd,UINT id,LPCSTR path,char **szAllFileNames,
                        const char *pads,const char *separator,char space);

#ifdef __cplusplus
}
#endif


#endif