/*******************************************************************************
 FONTTI.H

 - Fontin vaihto aktiivisena olevaan ikkunaan tai jos ikkuna
   kuuluu ryhmn kaikkiin ryhmn kuuluviin ikkunoihin.

 - BY  Mika Haverila 16.11.1994, vl -95->


/******************************************************************************/
#ifndef FONTTI_H
#define FONTTI_H

#define FONT_ID_RANGE -123
/******************************************************************************/
#ifdef __cplusplus
extern "C" {
#endif


typedef struct {
  HFONT    hfont;          /* Kytettv fontti                */     /* FD */
  COLORREF clr;            /* Kytettv vri                  */     /* CD */
  HFONT    ohfont;         /* Vanha fontti                     */     /* FD */
  COLORREF oclr;           /* vanha vri                       */     /* CD */
  LOGFONT  lf;             /* Fontin rakenne                   */     /* FD */
  COLORREF aclrCust[16];   /* Kyttjn mrit. vrit          */     /* CD */
} tOneFont;

typedef struct {
  const char *WindowName;
  int *FontIDTables;
  tOneFont *Fonts;
} tFontChange;

/******************************************************************************/
int alusta_fontti(const char *ini,const char *topic,tOneFont *f);
int vaihda_fontti(HWND hWnd,tOneFont *f,int redraw);
int poista_fontti(const char *ini,const char *topic,tOneFont *f);
int valitse_fontti(HDC hDC,tOneFont *f);
int palauta_fontti(HDC hDC,tOneFont *f);

int alusta_fontit(HWND ,const char *,tFontChange *);
int poista_fontit(HWND ,const char *,tFontChange *);
int vaihda_fontit(HWND ,tFontChange * );
int vaihda_fontit_id(HWND hWnd,tFontChange *,int id);
tOneFont *EtsiYksiFontti(tFontChange *fc,int id);
/******************************************************************************/
#ifdef __cplusplus
}
#endif

#endif /* FONTTI_H */


