/**************/
/* help.c     */
/****************************************************************************

  MODULE:  help.c
  PURPOSE: Tehdn sisltpohjainen avustus.
  AUTHOR:  Vesa Lappalainen 27.8.1994
  UPADTE:
  USAGE:   Kirjaston kyttmiseksi tarvitaan tiedostot:
               help.c
               help.h

           Sitten ohjelmaan Help-tiedostosta riippuen 1) tai 2)
           tai molemmat tavat.  2) on jossain mrin helpompi
           ohjelman kannalta, mutta vaatii enemmn valmisteluja
           Help-tiedossa:

        1) Haluttuun nappulan ksittelyyn laitetaan kutsu

             DoHelpOnFocus(hWnd,"oma.hlp",HelpTable)

           miss, HelpTable on taulukko, miss sanotaan mit
           id-numeroa vastaa mikkin hakusana.  Esim:

            tHelpTable HelpTable[] = {
              { IDR_OTHER, "naapuri"    },
              { IDR_THIS,  "oma"        },
              { ID_SCALE,  "mittakaava" },
              { 0 }
            };

           Kun kyttj painaa valittua nppint (esim. ctrl-F1),
           katsotaan mill kontrollilla on focus ja sen id-numeron
           mukaan etsitn vastaava avainsana taulukosta ja pyydetn
           avustusta avainsanan mukaan.  Jos avainsanaa ei lydy, nytetn
           hakulaatikko.

        2) Jos Help-tiedostoa tehtess on .HPJ tiedostossa [MAP] osassa
           kytetty samoja ID-numeroita kuin ohjelman .H tiedostossa
             Esim:
              [MAP]
              #include <vaihtaja.h>
           ja Help-tiedostossa on kutakin IDR_OTHER jne. asiaa vastaten
           alaviite (#), niin voidaa kytt kutsua:

            DoHelpOnFocusID(hWnd,"oma.hlp")

           ja mitn taulukkoa ei tarvitakaan.  Tllin etsitn aluksi
           mik ikkuna (ohjain) on aktiivinen ja jos sill on is, niin
           annetaan avustusta ohjaimen ID:n mukaan.  Jos aktiivisella
           ikkunalla ei ole is, on kysesss todennkisesti pikkuna
           ja avustukseksi kynnistetn Search-ikkuna.  Joissakin
           lapsi-ikkunatapauksissa voi homma silti menn pieleen ja
           tulee ilmoitus "Topic not found!".  Samoin ky, jollei Help-
           tiedostossa ole avustusta jokaiselle ohjaimelle erikseen.

****************************************************************************/
#include <windows.h>
#include <windowsx.h>
#include "help.h"

/***************************************************************************/
int DoHelpOnFocus(HWND hWnd,const char *HelpFile,tHelpTable *HelpTable)
{
  int i,id = GetWindowID(GetFocus());
  if ( id == 0 ) return 0;
  for (i=0; HelpTable[i].id; i++)
    if ( HelpTable[i].id == id )
      return WinHelp(hWnd,HelpFile,
                     HELP_PARTIALKEY,(DWORD)(LPSTR)HelpTable[i].keyword);
  return WinHelp(hWnd,HelpFile,HELP_PARTIALKEY,(DWORD)(LPSTR)"");
}

/***************************************************************************/
int DoHelpOnFocusID(HWND hWnd,const char *HelpFile)
{
  HWND hCtl = GetFocus(), hWndP = GetParent(hCtl);
  int id = GetWindowID(GetFocus());

  if ( id == 0 || hWndP == NULL )
    return WinHelp(hWnd,HelpFile,HELP_PARTIALKEY,(DWORD)(LPSTR)"");
  return WinHelp(hWnd,HelpFile,HELP_CONTEXT,id);
}