/**************/
/* transdlg.c */
/****************************************************************************
  PROGRAM: transdlg.c
  PURPOSE: Knt dialogit kielelt toiselle
  AUTHOR:  Vesa Lappalainen 29.8.1993
  UPDATE:  21.10.1994:
            + SetNoTranslate("* - [*;[*]");
  USAGE:
    Projektiin laitettava: transdlg.c, language.c, mjonot.c

    Jos halutaan knt dialogeja eri kielien vlill toimitaan seuraavasti:
    1) Kirjoitetaan kaikki dialogit ja menut tietyll kielell
       (vaikkapa suomeksi kun siin on pisimmt sanat).

    2) Niiden dialogien ja menujen tunnukset, joiden ei haluta kntyvn,
       nimetn numerolle joka on suurempi kuin kutsulla
         SetTranslateLimit(raja)

       asetettu raja.  Oletuksena raja on 5000.

       Kntymttmiksi kannattaa usein laittaa ainakin Edit-kentt ja
       Combo-boxit.  Tosin jos kielt ei vaihdella edestakaisin ohjelman
       ajon aikana, vaan vaihto tehdn tasan yhden kerran ohjelma alussa,
       ei kntymttmi kentti vlttmtt tarvita.
       Tietysti edit-kenttkin voi olla knnettv, mutta tllin
       kieleten edestakaisissa vaihdoissa voi sanasto lisnty kohtuuttoman
       suureksi.

    3) Ohjelman aluksi tai ennen ensimmisen dialogin knnistymist
       listn kutsu:
         ReadLanguage(oma_inifile,kaannos_polku,oletus_kaannos)

       joka lukee omasta .INI-tiedostosta mritykset:
         [General]
         Language=0
         Translate=C:\WINDOWS\WINCD\wincd.tra

       Kielten numeroissa 0 on oletuskieli, -1 on oletuskieli ja
       kielt samalla kielen vaihdon (sst muistia, jos
       kielt ei haluta vaihtaa) ja muut ovat vieraita kieli.
       Kytnnss on language.h:ssa on mritelty KIELIA=2,
       joten vain numerot -1,0 ja 1 ovat kytss
       Jos rivi Translate= ei ole, luetaan knns tiedostosta
       kaannospolku\oletus_kaannos

    4) Aina kunkin dialogin WM_INITDIALOG-viestiin liitetn kutsu:
         TranslateDialog(hDlg,0)

       Tm knt ikkunan (ei tavitse olla dialogi) otsikon ja
       kaikkien sen lapsi-ikkunoiden otsikot (dialogissa mm.
       static.kentt) sek menut aktiiviselle kielelle.
         Modeless-dialogien tapauksessa voidaan mys (jos ei haluta
         muuttaa valmista dialogin ikkunafunktiota) tehd:
            hDlg = CreteDialog(...
            TranslateDialog(hDlg);
         Modal-dialogeille tm ei onnistu, koska niille ei palata
         luomiskutsusta ennenkuin dialogi on hvinnyt.

         Toinen tapa vltt valmiin ikkunafunktion muuttaminen (jos esim. jopa
         saatu vain .OBJ tai .LIB) on uuden ikkunafunktion tekeminen, joka
         ensin kutsuu alkuperist funktiota ja sitten WM_INITDIALOG
         tapauksessa vaihtaa viel kielen.  Tm voidaan helpoiten tehd alla
         olevalla makrolla
           TrINITPROC

         Olemassa olevaan dialogin funktioon voidaan mys list alkuun
         kutsu:

           TranslateHandler(hWnd,message,wParam,lParam);

         joka tarkistaa onko kyseess dialogin alustus ja jos on,
         niin knt dialogin.

    5) Muihin tulostettaviin teksteihin laitetaan kutsu
         T(teksti).

       Esim. jos normaalisti kirjoitettaisiin:
         MessageBox(hWnd, "Tallennus eponnistui!",WTITLE,...

       kirjoitetaan muodossa:
         MessageBox(hWnd, T("Tallennus eponnistui!"),T(WTITLE),...

    6) Ohjelman loppuun listn kutsu:
         SaveLanguageAndFree(oma_inifile,kaannos_polku,oletus_kaannos)

    7) Jos halutaan kielen vaihto kesken ohjelman suorituksen, vaihdetaan
       kynniss olevat dialogit ensin suomen kielelle takaisin kutsulla
         TranslateDialog(hDlg,1)

       sitten vaihdetaan kieli halutuksi
         set_language(kieli)

       ja knnetn dialogit jlleen.

       Jos vaihdellaan vain kahden kielen vlill, ja aktiivisena on
       vain yksi dialogi (tai ketju, jolle voidaan ilmaista yhteinen
       esi-is) voidaan kytt kutsua:
         FlipDialogLanguage(hDlg,back)

       joka tuo dialogin vieraalta kielelt suomen kielelle tai
       vaihtaa suomen kielisen dialogin kielelle kieli.  Tm toimii
       hyvin, jos on vain yksi aktiivinen dialogi.  Jos aktiivisia
       (rinnakkaisia, isttmi) dialogeja on useita, pit menetell
       ensin mainitulla tavalla tai sulkea kaikki aktiiviset dialogit
       ja avata ne uudelleen.

    8) Edellisen tilalla ehk kaikkein helpointa on kytt
         TranslateProgram(hWnd,back)
       joka knt kaikki ohjelman ikkunat joko vieraalle kielelle
       (back=0) tai takaisin (back=1).  Jos knnetn takaisin, pit
       kieli olla ennen kntmist 1 ja kntmisen jlkeen kieli
       muuttuu automaattisesti 0:ksi.

       Viel on olemassa flip-kutsuja, jotka vaihtavat kahden kielen
       vlill.  Ks. seuraava luettelo.

============
Aliohjelmat: (transdlg.c)
============

int SetTranslateLimit(int l)
----------------------------
 - asettaa sen tunnusnumerorajan, jota isompien tunnusten ikkunoita
   ei knnet, oletus ilman kutsua on 5000

int SetNoTranslate(LPCSTR *s)
----------------------------
 - asettaa maskin, jonka mukaisia sanoja ei knnet IKKUNOISTA.
   (T knt riippumatta tst).
   Esim jos s = "*a;*b", niin ei knnet a- ja b-loppuisia sanoja.

int ChangeWindowTitle(HWND hWnd,LPARAM back)
----------------------------------------------
 - knt ikkunan otsikon vieraalle kielelle jos back==0 ja suomeksi
   jos back==1.  Yleens tt ei kytet, vaan myhemmt aliohjelmat
   kutsuvat tt.

int TranslateMenu(HWND hWnd,int back)
-------------------------------------
 - knt menun vieraalle kielelle tai suomeksi

int TranslateDialog(HWND hDlg,int back)
---------------------------------------
 - knt ikkunan ja sen kaikkien lapsi-ikkunoiden tekstit ja menut
   back==0  => vieras kieli, back==1 => suomen kieli

int TranslateProgram(HWND hDlg,int back)
---------------------------------------
 - knt kaikki ohjelman ikkunat, muuten ks ed.

int TranslateProgramAndRead(HWND hWnd,const char *transfile)
------------------------------------------------------------
 - knt ohjelman kaikki ikkunat ja lukee tarvittaessa transfile
   nimisen knnstiedoston.  Jos == NULL, niin kytetn sisisesti
   talletettua tiedoston nime, ks. ReadTranslate

void FlipDialogLanguage(HWND hDlg,int lang)
-------------------------------------------
 - vaihtaa dialogin kielen joko suomeksi tai vieraaksi kieleksi

int FlipProgramLanguage(HWND hDlg,int lang)
-------------------------------------------------
 - vaihtaa koko ohjelman kaikkien ikkunoiden kielen, muuten ks. edell

int SaveLanguageAndFree(char *inifile,char *path,char *def)
-------------------------------------------------
 - tallettaa nykyisen kieliasetuksen ja knstiedoston nimen .INI-tiedostoon.
   file on .INI-tiedoston nimi. path\def on knnstiedoson nimi.
   Jos .INI-tiedostosa on jo ennestn kielitiedoston nimi, ei nime talleta.
   .INI-tiedoston muoto:
         [General]
         Language=0
         Translate=C:\WINDOWS\WINCD\wincd.tra
   Jos path ja def == NULL, niin nimen kytetn ini-nimest
   muodostettua nime (.ini => .tra).  Jos inifile == NULL, niin
   kytetn sisisesti tallettua nime ( ReadLanguage... )

int ReadLanguage(char *inifile,char *path,char *def)
-------------------------------------------------
 - lukee .INI-tiedostosta kielitiedot ja lukee tmn jlkeen
   joko .INI-tiedostosta lytyneen knnslistan tai jollei siell
   ole nime, niin path\def-nimisen knnslistan.

int ReadLanguageIfNeeded(HWND hWnd,const char *inifile)
--------------------------------------------------------
 - lukee .INI-tiedostosta kielitiedot ja lukee tmn jlkeen
   knnslistan JOS vieras kieli on kytss, muuten vain sisisesti
   tallettaa knnstiedoston nimen.  Jos vieraskieli on kytss,
   niin vaihtaa mys sille kutsulla TranslateProgram(hWnd,0);

int ReadTranslate(const char *transfile,int lang)
--------------------------------------------------------
 - kuten read_translate, mutta jos transfile == NULL, niin
   kytetn sisisesti talletettua nime (ReadLanguage...)

LONG TranslateHandler(HWND hWnd, UINT message,WPARAM wParam, LPARAM lParam)
--------------------------------------------------------
  - knnksen ksittely jos message on WM_INITDIALOG, eli tmn
    kutsu voidaan list jokaisen dialogin ikkunafunktion alkuun
    tai tehd uusi ikkunafunktio makrolla TrINITPROC(old,new)

Muut aliohjelmat:  ks. language.c

============
Makrot: (language.h)
============
T("jono")    - knt jonon oletuskielelle, jos jonoa ei ole, lis
               knnstiedostoon rivin
                "jono" "@@jono"
               ja palauttaa samalla tekstin "@@jono", josta helposti
               huomaa, ettei sanaa ole viel kytetty.

TA("jono",a) - kuten edell, muutta a mr listnk sana vai ei
TB("jono")   - knt jonon oletuskielest suomen kielelle, ei lis
               knnstiedostoon.

============
Makrot: (transdlg.h)
============
TrINITPROC(of,nf,type) - tekee uuden ikkunafunktion uf, joka hoitaa alustuksessa
               tarvittavat hommat kun alkuperinen ikkunafuktio on ne hoitanut.
               Esim. jos on valmis ikkunafunktio About-dialogin ksittelemiseksi,
               niin dialogin kielen vaihto voidaan tehd vaikkapa seuraavasti:
                 BOOL CALLBACK export_ About(....)
                 ...
                 TrINITPROC(About,IAbout,BOOL)
               ja sitten dialogin luomisessa ikkunafunktioksi ilmoitetaan IAbout.


============
Toiminnasta:
============

  Kntminen tehdn ajon aikana, eik se muuta varsinaisia Windowsin
  sisisi tietorakenteita (.RES-osassa olevia).  Nin ollen
  jos knnetty dialogi suljetaan ja avataan uudelleen ilman ett
  sen WM_INIT.. osassa on TranslateDialog-kutsua, tulee dialogi
  aina suomen (alkuperisell) kielell.

  Kntminen perustuu sanastoon ja makroihin T, TA ja TB.  Sanastotiedosto on
  muotoa:
    "lause 1 suomeksi" "sentence 1 in english"
    "lause 2 suomeksi" "sentence 2 in english"

  Jos sana puuttuu sanastotiedostosta, niin makrot T ja TA lisvt tiedostoon
  rivin
    "lause 1 suomeksi" "@@lause 1 suomeksi"

  Nm @@-alkuiset sanonnat pit sitten joskus muistaa pivitt.
  Siis itse knnstyn tekeminen voidaan tehd vasta kun ohjelmaa
  on jo ajettu useita kertoja ja nin sanastosta puuttuvat sanat
  saatu merkityksi.

  Ohjelman kehityksess riitt vain kirjoittaa jokainen tulostuva
  teksti T-makron sislle.  Jos kielen pidetn -1, ei itse
  knnst yritetkn tehd.  Tietysti T-makro voidaan korvata
  makrolla
    #define T(sana) sana

  jolloin itse knnsaliohjelmia ei edes tarvita ohjelman kehityksen
  aikana.

  C-kielen %-merkit silytetn sellaisenaan, eli kutsua
    sprintf(s,"Olen %d vuotta vanha.",ika)

  vastaava kntyv kutsu on
    sprintf(s,T("Olen %d vuotta vanha."),ika)

  ja vastaava knnstiedoston rivi on muotoa:
    "Olen %d vuotta vanha." "My age is %d"

  Nin sanajrjestys riippuavat asiat voidaan kiert suht. helposti.

HUOM!
  Muista teksteiss C-kielen % snnt, eli % tulostuslauseen tullessa
  pit kirjoittaa %%.  Muissa teksteiss kuin ?printf( ja ?scanf-
  teksteiss %-kirjoitetaan normaalisti.
  \ kirjoitetaan \\ ja rivinvaihto \n jne..

  Mitn ongelmia ei kuitenkaan tule, kun vain matkitaan
  knnstiedoston suomenkielist saraketta ja erikoismerkkien
  muotoa siin.

========
Kojattu: 21.10.1994
========
  Jos dialogin otsikossa on muuttuvaa teksti, lisytyy sekin
  aina knnslistaan (esim. tiedoston nimi.)  Miten tm
  voitaisiin vltt.  Tarvitaan varmaan tekstifiltteri, jolla
  sanotaan ett minklaisia asioita EI saa knt
  (Jos otsikko on EDIT - [koe.txt], niin filtteri voisi olla
   "* - [*" tms.).

========
Kojattu: 13.11.1996 /vl
========
  32-bittisess TranslateProgram muutettu kasittelemaan saikeen ikkunat
  Samoin 0xFFFF vaihdettu -1 (koska 32-bittisess piti olla 0xffffffff

========
Vikoja:
========
  Em. maskilla otsikko j kokonaan kntymtt ja se pit
  pyyt uudelleen! 

****************************************************************************/
#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include "portable.h"
#include "mjonot.h"
#include "transdlg.h"

static unsigned int TranslateLimit = TRANSLATE_LIMIT;
static LPCSTR NoTranslate = "";

/***************************************************************************/
static int IsNoTranslate(const char *s)
{
  LPCSTR pe,ps = NoTranslate;
  char nt[100];
  int nc,n,mn = sizeof(nt)-1;

  if ( NoTranslate == NULL ) return 0;
  do {
    pe = _fstrchr(ps,';');
    n = (int)(pe ? pe - ps : _fstrlen(ps));
    nc = n < mn ? n : mn;
    _fstrncpy(nt,ps,nc); nt[nc] = 0;
    if ( wildmat(s,nt) == 0 ) return 1;
    ps += n+1;
  } while ( pe );
  return 0;
}


/***************************************************************************/
int SetNoTranslate(LPCSTR s)
{
  NoTranslate = s ? s : "";
  return 0;
}

/***************************************************************************/
int SetTranslateLimit(int l)
{
  int old_val = TranslateLimit;
  TranslateLimit = l;
  return old_val;
}

/***************************************************************************/
int ComboBoxChild(HWND hWnd)
/* ComboBoxin lapsi on Edit ikkuna ja sit ei knnet!                    */
{
  char s[20];
  HWND phWnd;
  GetClassName(hWnd,N_S(s));
  if ( strcmp(s,"Edit") != 0 ) return 0;

  phWnd = GetParent(hWnd);
  if ( !phWnd ) return 0;
  GetClassName(phWnd,N_S(s));

  if ( strcmp(s,"ComboBox") != 0 ) return 0;

  return 1;
}

/***************************************************************************/
int ChangeWindowTitle(HWND hWnd,LPARAM back)
/* Vaihdetaan otsikko                                                      */
/* Paluu  0 = vaihdettiin
**        1 = ei teksti
**        2 = ei saa knt
**        3 = ComboBoxin lapsi => ei knnet!
** Jos ikkunan id on laiton ja kyseess on lapsi-ikkuna, niin ei knnet.
** Ei-lapsi-ikkunan id voi olla sen menun kahva, ja tllaisen ikkunan
** otsikko kyll knnetn.
*/
{
  char s[200];
  UINT id;
  if ( !GetWindowText(hWnd,N_S(s)) ) return 1;
  id = GetWindowID(hWnd);

  if ( ( id >= TranslateLimit && (id&0xffff) != 0xffff && GetParent(hWnd) ) ||
       IsNoTranslate(s)
     ) return 2;

  if ( ComboBoxChild(hWnd) ) return 3;

  SetWindowText(hWnd,( back ? TB(s) : TA(s,1) ));
  return 0;
}


/***************************************************************************/
static int IsHelpText(char *s)
{
  char st[10],*p;
  strncpy(st,s,sizeof(st)-1); st[sizeof(st)-1]=0;

  p = strchr(st,'&');
  if ( p )           /* Delete & */
    while ( *p ) {
      *p=*(p+1); p++;
    }

  return ( strcmpi(st,"Help") == 0 || strcmpi(st,"Apua") == 0 );
}

static   char s[200];

/***************************************************************************/
static int translate_hmenu(HMENU hMenu,int back)
{
  int i,n;
  UINT id;
  HMENU hSub;
  UINT state;
  if ( !hMenu ) return 1;

  n = GetMenuItemCount(hMenu);
  if ( n<=0 ) return 1;

  for (i=0; i<n ; i++) {
    if ( ( id = GetMenuItemID(hMenu,i) ) == 0 ) continue;
    state = GetMenuState(hMenu,i,MF_BYPOSITION);
    if ( id == -1 ) { /* Popup menu, jonka kytn Win on tehnyt hankal */
      hSub = GetSubMenu(hMenu,i);
      translate_hmenu(hSub,back);
/*    state &= ~MF_APPEND & ~MF_DELETE; /* Nm pit poistaa              */
      state = MF_POPUP; /* Itse asiassa kaikki POP-UP asiat sekaisin!!!    */
      /* Ja windows hukkaa Popup menun tilasta esim. Help-bitin!           */
      if ( GetMenuString(hMenu,i,N_S(s),MF_BYPOSITION) > 0 ) {
        if ( IsHelpText(s) ) state |= MF_HELP;
        if ( !IsNoTranslate(s) )
          ModifyMenu(hMenu, i, MF_BYPOSITION | state, (UINT)hSub,
                     ( back ? TB(s): T(s)) );
      }
    }
    else
      if ( id < TranslateLimit &&
           GetMenuString(hMenu,i,N_S(s),MF_BYPOSITION) > 0 &&
           !IsNoTranslate(s) )
        ModifyMenu(hMenu, i, MF_BYPOSITION | state, id,( back ? TB(s): T(s)) );
  }
  return 0;
}

/***************************************************************************/
int TranslateMenu(HWND hWnd,int back)
{
  HMENU hMenu=GetMenu(hWnd);

  translate_hmenu(hMenu,back);
  DrawMenuBar(hWnd);
  return 0;
}

/***************************************************************************/
BOOL CALLBACK _export EnumChilds(HWND hWnd,LPARAM back)
{
  ChangeWindowTitle(hWnd,back);
  return TRUE;
}

/***************************************************************************/
int TranslateDialog(HWND hDlg,int back)
{
  FARPROC EnumProc = MakeProcInstance((FARPROC)EnumChilds,GetWindowInstance(hDlg));

  if ( language()<=0 ) return 0;
  ChangeWindowTitle(hDlg,back);
  EnumChildWindows(hDlg,(WNDENUMPROC)EnumProc,back);

  (void)FreeProcInstance(EnumProc);

  TranslateMenu(hDlg,back);
  InvalidateRect(hDlg,NULL,TRUE);

  return 0;
}

/***************************************************************************/
BOOL CALLBACK _export EnumProgs(HWND hWnd,LPARAM back)
{
  TranslateDialog(hWnd,(int)back);
  return TRUE;
}

/***************************************************************************/
int TranslateProgram(HWND hDlg,int back)
{
  FARPROC EnumProc = MakeProcInstance((FARPROC)EnumProgs,GetWindowInstance(hDlg));
#ifndef __WIN32__
  HTASK hTask = GetCurrentTask();
  (void)hDlg;
  if ( language()<=0 ) return 0;
  EnumTaskWindows(hTask,(WNDENUMPROC)EnumProc,back);
#else
  DWORD thNr = GetWindowThreadProcessId(hDlg,NULL);
  if ( language()<=0 ) return 0;
  EnumThreadWindows(thNr,(WNDENUMPROC)EnumProc,back);
#endif

  (void)FreeProcInstance(EnumProc);
  if ( back ) set_language(0);

  return 0;
}

/***************************************************************************/
int FlipDialogLanguage(HWND hDlg,int lang)
{
  int l = language();
  if ( l < 0 ) return 0;
  if ( l ) { TranslateDialog(hDlg,1); set_language(0); }
  else     { set_language(lang); TranslateDialog(hDlg,0); }
  return 0;
}

/***************************************************************************/
int FlipProgramLanguage(HWND hDlg,int lang)
{
  int l = language();
  if ( l < 0 ) return 0;
  if ( l ) { TranslateProgram(hDlg,1); set_language(0); }
  else     { set_language(lang); TranslateProgram(hDlg,0); }
  return 0;
}

/***************************************************************************/
char *FullName(const char *path,const char *name,
                      const char *file,const char *ext)
{
  char *p;
  kopioi_jono(N_S(s),path);
  if ( *s && s[strlen(s)-1] != '\\' ) liita_jono(N_S(s),"\\");
  liita_jono(N_S(s),name);
  if ( *s ) return s;
  kopioi_jono(N_S(s),file);
  p = strrchr(s,'.'); if ( p ) *p = 0;
  liita_jono(N_S(s),ext);
  return s;
}

static char tra_name[100];
static char ini_name[100];
#define INI(ini) (ini?ini:ini_name)
/***************************************************************************/
static int SaveUsedLanguage(const char *inifile)
/* Talletetaan kieli ja knnstiedoston paikka, jollei sit jo ole.       */
{
  int lang = language();
  char str[10];
  sprintf(str,"%i",lang);
  WritePrivateProfileString("General","Language",str,INI(inifile));
  return 0;
}

/***************************************************************************/
int SaveLanguageAndFree(const char *inifile,const char *path,const char *def)
/* Talletetaan kieli ja knnstiedoston paikka, jollei sit jo ole.       */
{
  char str[10];
  const char *p = "";
  SaveUsedLanguage(inifile);
  if ( GetPrivateProfileString("General","Translate","",N_S(str),INI(inifile)) == 0 ) {
    if ( def && def[0] ) p = FullName(path,def,INI(inifile),".tra");
    WritePrivateProfileString("General","Translate",p,INI(inifile));
  }
  free_translate();
  return 0;
}

/***************************************************************************/
static int GetTranslateName(const char *inifile,const char *path,const char *def)
{
  int lang=GetPrivateProfileInt("General","Language",0,inifile);
  GetPrivateProfileString("General","Translate",
                          FullName(path,def,inifile,".tra"),N_S(tra_name),inifile);
  if ( tra_name[0] == 0 ) kopioi_jono(N_S(tra_name),FullName(path,def,inifile,".tra"));
  kopioi_jono(N_S(ini_name),inifile);
  return lang;
}

/***************************************************************************/
int ReadLanguage(const char *inifile,const char *path,const char *def)
{
  int lang = GetTranslateName(inifile,path,def);
  return read_translate(tra_name,lang);
}

/***************************************************************************/
int ReadLanguageIfNeeded(HWND hWnd,const char *inifile)
{
  int ret, lang = GetTranslateName(inifile,NULL,NULL);
  if ( lang <= 0 ) return 0;
  ret = read_translate(tra_name,lang);
  TranslateProgram(hWnd,0);
  return ret;
}

/***************************************************************************/
int ReadTranslate(const char *transfile,int lang)
{
  const char *p = transfile;
  if ( p == NULL ) p = tra_name;
  return read_translate(p,lang);
}

/****************************************************************************/
int TranslateProgramAndRead(HWND hWnd,const char *transfile)
{
  if ( language() == 1 ) return 0;
  ReadTranslate(transfile,1);
  TranslateProgram(hWnd,0);
  return 0;
}

/****************************************************************************/
int FlipProgramLanguageAndRead(HWND hWnd,const char *transfile)
{
  int ret,l = language();
  if ( l < 0 ) return 0;
  if ( l )  ret = TranslateProgram(hWnd,1);
  else ret = TranslateProgramAndRead(hWnd,transfile);
  SaveUsedLanguage(NULL);
  return ret;
}

/***************************************************************************/
LONG TranslateHandler(HWND hWnd, UINT message,WPARAM wParam, LPARAM lParam)
{
#pragma argsused
  if ( message == WM_INITDIALOG || message == WM_CREATE ) {
    TranslateDialog(hWnd,0);
  }
  return -1;
}

