#ifndef TRANSDLG_H
#define TRANSDLG_H
#define TRANSLATE_LIMIT 5000

#include "incwin.h"

#include "language.h"
#ifdef __cplusplus
extern "C" {
#endif
int SetTranslateLimit(int l);
int SetNoTranslate(LPCSTR s);
int TranslateMenu(HWND, int);
int TranslateDialog(HWND, int);
int TranslateProgram(HWND, int);
int FlipDialogLanguage(HWND,int);
int FlipProgramLanguage(HWND, int);
int SaveLanguageAndFree(const char *inifile,const char *path,const char *def);
int ReadLanguage(const char *inifile,const char *path,const char *def);
int ReadLanguageIfNeeded(HWND hWnd,const char *inifile);
int ReadTranslate(const char *transfile,int lang);
int TranslateProgramAndRead(HWND hWnd,const char *transfile);
int FlipProgramLanguageAndRead(HWND hWnd,const char *transfile);
LONG TranslateHandler(HWND hWnd, UINT message,WPARAM wParam, LPARAM lParam);

#define TrINITPROC(oldf,newf,type )                                           \
  type CALLBACK _export newf(HWND hWnd, UINT message,                         \
                                    WPARAM wParam, LPARAM lParam)             \
  {                                                                           \
    type ret=oldf(hWnd,message,wParam,lParam);                                \
    if ( message != WM_INITDIALOG && message != WM_CREATE ) return ret;       \
    TranslateDialog(hWnd,0);        return ret;                               \
  }

#ifdef __cplusplus
}
#endif
#endif  /* TRANSDLG_H */