/**************/
/* tulostus.h */
/**************/

#ifndef TULOSTUS_H
#define TULOSTUS_H

#include "incwin.h"

#ifndef _COMMDLG_H
#include <commdlg.h>
#endif

#ifndef __WIN32__
#ifndef __PRINT_H
#include <print.h>
#endif
#endif

#ifndef CHECKER_H
#include "checker.h"
#endif

#define PSC_DISPLAY -1
#define PSC_WINDOW  -2

#ifdef __cplusplus
extern "C" {
#endif
typedef struct {
  int BreakPrinting;          /* Onko tulostus keskeytetty                  */
  int Printing;               /* Onko tulostus menossa                      */
  HWND hWnd;                  /* Tulostavan ikkunan kahva                   */
  HWND PrinterDialogHWND;     /* Kahva keskeytysikkunaan                    */
  HINSTANCE hInstance;        /* Koko ohjelman esiintym                    */
  FARPROC PrinterDlgFunc;     /* Keskeytysikkunan funktio                   */ 
  FARPROC PrinterBreakFunc;   /* Printtauksen aikana toimiva viestisilmukka */
  HDC hPrinterDC;             /* Tulostimen laiteyhteyden kahva             */
  char DriverName[80];        /* Tulostimen ohjaimen nimi                   */
  char DeviceName[80];        /* Tulostimen nimi                            */
  char PortName[80];          /* Tulostusportin nimi                        */
  DEVMODE DevMode;            /* Edellisen kerran DevModen talletus         */
  char DevExtra[400];         /* ja siihen liittyvt ylim. tavut            */
  char DevNames[500];         /* Kirjoitimen ohjaimen tietojen talletus     */
  long     DevSize;           /* DevMode-tietueelle varattu koko (vaihtelee)*/
  long     NameSize;          /* Nimille varattu koko (vaihtelee)           */
  PRINTDLG  pd;               /* Tulostimen kysymisdialogissa tarv. tietue  */
} PrinterType;

extern PrinterType GlobalPrinter;
int SetupPrinter(int);
HDC StartPrinting(HWND,int);
int StopPrinting(HWND,HDC);
void InformPrinter(HINSTANCE);
#ifdef __cplusplus
}
#endif
#endif /* TULOSTUS_H */